/*
** 50LINE.C     50 line mode detection and restoration for
**              Turbo C.
**
** Will Menninger, 7-13-94, taken entirely from ASM program written
** Walter Oney of Rational Systems.
**
** I added this to GRAPHICS.LIB, the Turbo C graphics library.
**
*/

#include <stdio.h>
#include <dos.h>
#include <graphics.h>

static int  textmode;
static int  textpage;
static int  textcurs;
static int  textfont;
static int  textattr;
static int  bordercolor;


/*
** Read key attributes of the text screen so that it can be correctly
** restored, including the font (for 50 and 43 line modes).  Call
** the function restore_text_mode() to restore.
**
** If the mode read is not 3, then 50 line mode is reverted to when
** restore is called.
**
*/
void far _Cdecl read_text_mode(void)

    {
    union REGS  r;

    r.h.ah = 0xf;
    int86(0x10,&r,&r);
    textmode = r.h.al;
    textpage = r.h.bh;
    r.h.ah = 0x3;
    int86(0x10,&r,&r);
    textcurs = r.x.cx;
    r.x.ax = 0x1130;
    r.h.bh = 0;
    int86(0x10,&r,&r);
    if (r.x.cx == 0x8)
        textfont = 0x1112;   /* 8 x 8 */
    else
        if (r.x.cx == 0x10)
            textfont = 0x1114;  /* 8 x 16 */
        else
            textfont = 0x1111;  /* 8 x 14 */
    r.h.ah = 0x8;
    r.h.bh = textpage;
    int86(0x10,&r,&r);
    textattr = r.h.ah;
    bordercolor = (r.h.ah >> 4);
    r.x.ax = 0x1a00;
    int86(0x10,&r,&r);
    if (r.h.al == 0x1a && r.h.bl == 0x8)
        {
        r.x.ax = 0x1008;
        int86(0x10,&r,&r);
        bordercolor = r.h.bh;
        }
    if (textmode!=3)
        {
        textmode=3;
        textfont=0x1112;
        textcurs=0x0607;
        textattr=7;
        textpage=0;
        }
    }


void far _Cdecl restore_text_mode(int lines50)

    {
    union REGS  r;

    r.h.al = textmode;
    r.h.ah = 0;
    int86(0x10,&r,&r);            /* Restore text mode        */
    r.x.ax = 0x500;
    int86(0x10,&r,&r);            /* Force display of page 0  */
    r.x.ax = textfont;
    r.h.bl = 0;
    int86(0x10,&r,&r);            /* Set font                 */
    r.h.ah = 0x3;
    r.h.bh = 0;
    int86(0x10,&r,&r);            /* Get cursor to reset MCGA */
    r.h.al = textpage;
    r.h.ah = 0x5;
    int86(0x10,&r,&r);            /* Restore proper page      */
    r.x.cx = textcurs;
    r.h.ah = 0x1;
    int86(0x10,&r,&r);            /* Restore cursor           */
    r.x.ax = 0x1001;
    r.h.bh = bordercolor;
    int86(0x10,&r,&r);            /* Restore border color     */
    r.x.ax = 0x600;
    r.h.bh = textattr;
    r.x.cx = 0;
    r.h.dl = peekb(0x40,0x4a)-1;
    r.h.dh = peekb(0x40,0x84);
    int86(0x10,&r,&r);            /* Clear screen             */
    }
